Seguimiento de evaluación de conjuntos de reglas

La utilidad nftables (y, en menor medida, iptables) permite examinar cómo se evlúa un paquete y qué reglas del conjunto de reglas coincidieron con él. Para utilizar esta función especial, se insertan "reglas de seguimiento" en una ubicación adecuada. Estas reglas seleccionan los paquetes que se deben rastrear. Supongamos que un host que proviene de la dirección I P[192.168 l 254](https://bitcu.co/192-168-1-254/) está tratando de alcanzar el servicio en la dirección S y el puerto P. Queremos saber qué transformación NAT se detecta, qué reglas se verifican y si el paquete se cae en alguna parte. [Banda de internet](https://cnpmjs.org/package/tracomalo)

Debido a que estamos tratando con conexiones entrantes, agregue una regla al punto de enlace previo al enrutamiento. Prerouting significa que el kernel aún no ha tomado una decisión sobre a dónde se enviará el paquete. Un cambio en la dirección de destino a menudo da como resultado que los paquetes se reenvíen en lugar de ser manejados por el propi [host](https://crates.io/crates/kromevpi).

Cada línea muestra una entrada de seguimiento de conexión. ¡Puede notar que cada línea muestra las direcciones y los números de puerto dos veces e incluso con direcciones invertidas y pares de puertos! Esto se debe a que cada entrada se inserta dos veces en la tabla de estado. La primera dirección cuádruple (dirección de origen y destino y puertos) son las registradas en la dirección original, es decir, lo que envió el iniciador. El segundo cuádruple es lo que conntrack espera ver cuando se recibe una respuesta del par. Esto resuelve dos problemas:

[Sitios github](https://cnpmjs.org/package/tropodrac)

Si una regla NAT coincide, como el enmascaramiento de la dirección IP, esto se registra en la parte de respuesta de la entrada de seguimiento de la conexión y luego se puede aplicar automáticamente a todos los paquetes futuros que forman parte del mismo flujo.

Una búsqueda en la tabla de estado será exitosa incluso si es un paquete de respuesta a un flujo que tiene alguna forma de traducción de dirección de red o puerto aplicada.

El cuádruple almacenado original (mostrado por primera vez) nunca cambia: es lo que envió el iniciador. La manipulación de[NAT](https://npm.runkit.com/kromevpi) solo altera la respuesta (segundo) cuadriplicado porque eso es lo que verá el receptor. Los cambios en el primer cuádruple serían inútiles: netfilter no tiene control sobre el estado de los iniciadores, solo puede influir en el paquete a medida que se recibe / reenvía. Cuando un paquete no se asigna a una entrada existente, conntrack puede agregarle una nueva entrada de estado. En el caso de [UDP](https://cnpmjs.org/package/kromevpi), esto ocurre automáticamente. En el caso de TCP, conntrack se puede configurar para agregar la nueva entrada solo si el paquete TCP tiene el bit SYN establecido. De forma predeterminada, conntrack permite que las capturas de flujo intermedio no causen problemas en los flujos que existían antes de que conntrack se activara.
